// this file is part of
// markonvert - Fortran unformatted record marker converter
//
// Copyright (C) 2005  Francesco Poli
//
// This work is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 2,
// as published by the Free Software Foundation.
// 
// This work is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this work; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

#include "config.h"
#include <string>
#include "usage.h"
#include "engine.h"

int
main(int argc, char* argv[])
{
    if (argc != 2)
      {
        mk::usage(argv[0]);
        std::exit(1);
      }

    bool upgrade;
    std::string opt(argv[1]);
    if (opt == "--from32to64")
      upgrade = true;
    else if (opt == "--from64to32")
      upgrade = false;
    else
      {
            mk::usage(argv[0]);
            std::exit(2);
      }

    try
      {
        mk::Engine engine;
        if (upgrade)
          engine.from32to64();
        else
          engine.from64to32();
      }
    catch(...)
      {
        std::cerr << "Something went wrong!" << std::endl;
        return 1;
      }

    return 0;
}
